//		Copyright © 1999  Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		Screen saver class.

#ifndef PENTOSAVER_H
#define PENTOSAVER_H

#include <image.h>
#include <List.h>
#include <Message.h>
#include <ScreenSaver.h>
#include <View.h>

class PentoSaver : public BScreenSaver
{
	typedef BScreenSaver inherited;
public:
	PentoSaver(BMessage *pMsg, image_id id);
	virtual ~PentoSaver(void);
	
	// Hook functions.
	virtual void Draw(BView *pView, int32 frame);
	virtual void StartConfig(BView *pConfigView);
	virtual status_t StartSaver(BView *pView, bool preview);

private:
	PentoSaver(const PentoSaver &orig);
	PentoSaver &operator =(const PentoSaver &orig);
	
	// Check if a tile fits.
	bool TileFits(int tile, int orientation, int x, int y);

	// Draw a tile.
	void DrawTile(BView *pView,
					  int tile, int orientation, int x, int y,
					  bool remove = false);

	// Data members.
	float mTileSize;
	int mWidth, mHeight;
	bool *mpArray;
	struct Location {
		int tile, orientation, x, y;
	} *mpLocations;
	BList mPlaced;
	bool mFull;
};
	
#endif // PENTOSAVER_H
